#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySailingSignCFG.h"
std::auto_ptr<M_ActivitySailingSignCFG> M_ActivitySailingSignCFG::msSingleton(nullptr);

int M_ActivitySailingSignCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingSignCFGData* M_ActivitySailingSignCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySailingSignCFGData>& M_ActivitySailingSignCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingSignCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySailingSignCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingSignCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mDesc = element->Attribute("Desc");
		data.mPlayerLvCond = element->IntAttribute("PlayerLvCond");
		data.mTurretLvCond = element->IntAttribute("TurretLvCond");
		{
			const char* AwardItemID = element->Attribute("AwardItemID");
			std::vector<std::string> vecAwardItemID;
			boost::split(vecAwardItemID, AwardItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemID[i].c_str(), &temp))
				{
					data.mAwardItemID.push_back(temp);
				}
			}
		}
		{
			const char* AwardItemCounts = element->Attribute("AwardItemCounts");
			std::vector<std::string> vecAwardItemCounts;
			boost::split(vecAwardItemCounts, AwardItemCounts, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecAwardItemCounts.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecAwardItemCounts[i].c_str(), &temp))
				{
					data.mAwardItemCounts.push_back(temp);
				}
			}
		}
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mUnlockDay = element->IntAttribute("UnlockDay");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySailingSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingSignCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySailingSignCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySailingSignCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySailingSignCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readInt(L, "PlayerLvCond", data.mPlayerLvCond);
		LuaCfgHelper::readInt(L, "TurretLvCond", data.mTurretLvCond);
		LuaCfgHelper::readVectorInt(L, "AwardItemID", data.mAwardItemID);
		LuaCfgHelper::readVectorInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "UnlockDay", data.mUnlockDay);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySailingSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingSignCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySailingSignCFG* M_ActivitySailingSignCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingSignCFG());
	}
	return msSingleton.get();
}

void M_ActivitySailingSignCFG::Release()
{
	msSingleton.reset(nullptr);
}
